"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Verifier = void 0;
var logger_1 = require("../logger");
var nativeVerifier_1 = require("./nativeVerifier");
var validateOptions_1 = require("./validateOptions");
var applyDefaults = function (options) { return (__assign({ timeout: 30000, logLevel: 'info' }, options)); };
var Verifier = (function () {
    function Verifier(options) {
        this.options = validateOptions_1.validateOptions(applyDefaults(options));
    }
    Verifier.prototype.verify = function () {
        logger_1.default.info('Verifying Pact Files');
        return nativeVerifier_1.verify(this.options);
    };
    return Verifier;
}());
exports.Verifier = Verifier;
exports.default = (function (options) { return new Verifier(options); });
//# sourceMappingURL=index.js.map