import { LogLevel } from '../logger/types';
export interface ConsumerVersionSelector {
    tag?: string;
    latest?: boolean;
    consumer?: string;
    deployedOrReleased?: boolean;
    deployed?: boolean;
    released?: boolean;
    environment?: string;
    fallbackTag?: string;
    branch?: string;
    mainBranch?: boolean;
    matchingBranch?: boolean;
}
export interface VerifierOptions {
    providerBaseUrl: string;
    provider?: string;
    pactUrls?: string[];
    pactBrokerUrl?: string;
    pactBrokerUsername?: string;
    pactBrokerPassword?: string;
    pactBrokerToken?: string;
    consumerVersionTags?: string[];
    providerVersionTags?: string[];
    providerBranch?: string;
    providerStatesSetupUrl?: string;
    providerStatesSetupTeardown?: boolean;
    providerStatesSetupBody?: boolean;
    publishVerificationResult?: boolean;
    providerVersion?: string;
    enablePending?: boolean;
    includeWipPactsSince?: string;
    consumerVersionSelectors?: ConsumerVersionSelector[];
    timeout?: number;
    logLevel?: LogLevel;
    disableSslVerification?: boolean;
    buildUrl?: string;
}
export declare type PactVerifierSource = {
    withProviderStateUrl: (url: string) => PactVerifierSource;
    withFilter: (description?: string, providerState?: string) => PactVerifierSource;
    withRequestTimeout: (timeout: number) => PactVerifierSource;
    verify: () => Promise<unknown>;
};
export declare type PactVerifierProvider = {
    withFileSource: (description: string) => PactVerifierSource;
    withDirectorySource: () => PactVerifierSource;
    withUriSource: () => PactVerifierSource;
    withPactBrokerSource: () => PactVerifierSource;
};
export interface NewVerifierOptions {
    providerBaseUrl: string;
    provider: string;
}
